<script setup>
import { ref, computed, nextTick, reactive } from "vue";
import { useStore } from "vuex";
import TreeView from "@components/Template/TreeView.vue";
import MediaTreeView from "@components/Template/MediaTreeView.vue";
import RunSVG from "@/assets/run.svg";
import ListenSVG from "@/assets/listen.svg";

const store = useStore();
const hoverOver = ref("");

const tabOpen = ref("tab_action");
const filter = reactive({ tab_action: "", tab_assets: "", tab_media: "" });
const filterInputNode = ref(null);

const sortedActions = computed(() => store.getters["game/actionsByPlugin"]);
const filteredActions = computed(() => {
  let filtered = {};
  for (const [plugin, actions] of Object.entries(sortedActions.value)) {
    const f = filter.tab_action;
    filtered[plugin] = actions.filter(
      (a) =>
        a.action.toLowerCase().includes(f) || a.plugin.toLowerCase().includes(f) || a.title.toLowerCase().includes(f),
    );
  }
  return filtered;
});
const groupedMedia = computed(() => {
  const groups = {
    Audio: [],
    Image: [],
    Other: [],
  };

  media.value.forEach((item) => {
    const extension = item.split(".").pop().toLowerCase();
    if (["mp3", "wav", "ogg", "oga", "m4a"].includes(extension)) {
      groups.Audio.push(item);
    } else if (["jpg", "jpeg", "png", "gif", "svg", "webp"].includes(extension)) {
      groups.Image.push(item);
    } else {
      groups.Other.push(item);
    }
  });

  return groups;
});

function setFilter(tabName) {
  tabOpen.value = tabName;
  filter.tab_action = "";
  filter.tab_assets = "";
  filter.tab_media = "";
  nextTick(() => {
    filterInputNode.value.focus();
    filterInputNode.value.setActive; // make the textbox/textarea the one that is going to receive mouse and keyboard input
    filterInputNode.value.select(); // some browsers require this line of code for it to work right
  });
}

const action_data = computed(() => store.state.level.variables.action_data ?? []);
const functions = computed(() => store.state.level.variables.functions ?? []);
const level_arguments = computed(() => store.state.level.variables.level_arguments ?? []);
const level_attributes = computed(() => store.state.level.variables.level_attributes ?? []);
const plugin_items = computed(() => store.state.level.variables.plugin_items ?? []);
const media = computed(() => store.state.game.media);

function setDragPayload(e, action) {
  e.dataTransfer.setData("action", action.action);
  e.dataTransfer.setData("mode", action.mode);
  e.dataTransfer.dropEffect = "copy";
}

function log(e, content) {
  console.log(content);
}

function openTab(e, tabName) {
  // hide everything
  const links = document.getElementsByClassName("tab-link");
  const tabs = document.getElementsByClassName("tab-content");
  Array.from(links).forEach((node) => node.classList.remove("is-active"));
  Array.from(tabs).forEach((node) => (node.style.display = "none"));
  // show selection
  const tabContainer = document.getElementById(tabName);
  setFilter(tabName);
  tabContainer.style.display = "block";
  e.currentTarget.classList.add("is-active");
}
</script>

<template>
  <aside class="toolbar-container">
    <div class="tabs is-boxed has-text-weight-semibold">
      <ul>
        <li class="tab-link is-active" @click="openTab($event, 'tab_action')">
          <a>ACTIONS</a>
        </li>
        <li class="tab-link" @click="openTab($event, 'tab_assets')">
          <a>VARIABLES</a>
        </li>
        <li class="tab-link" @click="openTab($event, 'tab_media')">
          <a>MEDIA</a>
        </li>
      </ul>
    </div>
    <div class="field">
      <p class="control has-icons-right">
        <input
          ref="filterInputNode"
          v-model="filter[tabOpen]"
          class="filter input is-primary mb-2"
          type="text"
          placeholder="Filter"
          @keyup.esc="filter[tabOpen] = ''"
        />
        <span class="icon is-small is-right">
          <button class="delete" @click="filter[tabOpen] = ''" />
        </span>
      </p>
    </div>
    <div class="tab-container is-scroll-container px-3 has-text-black">
      <!--  -->
      <!-- TAB ACTIONS CONTAINER -->
      <!--  -->
      <div id="tab_action" class="tab-content is-height-100">
        <div class="is-flex is-flex-direction-column is-height-100">
          <div v-if="filteredActions" class="is-scroll-container">
            <div v-for="(plugin, key, index) in filteredActions" :key="`plugin-${key}`">
              <!-- PLUGIN HEADING -->
              <h2 :class="['mb-1', 'has-text-weight-semibold', index != 0 ? 'mt-5' : '']">{{ key.toUpperCase() }}</h2>
              <!-- PLUGIN ACTION ITEM -->
              <div
                v-for="action in plugin"
                :key="`action-${action.title}`"
                :title="`${action.tooltip || action.action}`"
                class="bar-item"
                :class="$store.getters['adaptor/cssClassesByPlugin'](key)"
                draggable="true"
                @dragstart="setDragPayload($event, action)"
                @dblclick="log($event, action)"
                @mouseover="hoverOver = action.title"
                @mouseleave="hoverOver = ''"
              >
                <img
                  :src="action.mode == 'listen' ? ListenSVG : RunSVG"
                  alt="Action Type Icon"
                  :title="`This Action is of Mode ${action.mode}`"
                />
                <span class="is-flex-grow-1 pl-1 has-text-black has-text-weight-semibold">
                  {{ action.title }}
                </span>
                <a
                  v-if="hoverOver == action.title && action.documentation && action.documentation != ''"
                  class="is-flex pr-1"
                  :href="action.documentation"
                  target="_blank"
                  rel="noopener noreferrer"
                >
                  <Icon
                    class="has-text-grey"
                    :icon="'help-circle'"
                    :tooltip="`${action.tooltip}\nClick ? for help.`"
                    :interactive="false"
                  />
                </a>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!--  -->
      <!-- TAB VARIABLES CONTAINER -->
      <!--  -->
      <div id="tab_assets" class="tab-content is-height-100" style="display: none">
        <div class="is-flex is-flex-direction-column is-height-100">
          <div class="is-scroll-container">
            <!-- VARIABLES LEVEL VARIABLES HEADING -->
            <h2 class="mb-1 has-text-weight-semibold">LEVEL ATTRIBUTES</h2>
            <!-- VARIABLES LEVEL VARIABLES ITEM -->
            <TreeView :data="level_attributes" :filter="filter.tab_assets" />
            <!--  -->
            <!-- VARIABLES LEVEL VARIABLES HEADING -->
            <h2 class="mb-1 mt-5 has-text-weight-semibold">LEVEL ARGUMENTS</h2>
            <!-- VARIABLES LEVEL VARIABLES ITEM -->
            <TreeView :data="level_arguments" :filter="filter.tab_assets" />
            <!--  -->
            <!-- VARIABLES PLUGIN ITEMS HEADING -->
            <h2 class="mb-1 mt-5 has-text-weight-semibold">PLUGIN ITEMS</h2>
            <!-- VARIABLES PLUGIN ITEMS ITEM -->
            <TreeView :data="plugin_items" :filter="filter.tab_assets" />
            <!--  -->
            <!-- VARIABLES ACTION DATA HEADING -->
            <h2 class="mb-1 mt-5 has-text-weight-semibold">ACTION DATA</h2>
            <!-- VARIABLES ACTION DATA ITEM -->
            <TreeView :data="action_data" :filter="filter.tab_assets" />
            <!--    -->
            <!-- VARIABLES FUNCTIONS HEADING -->
            <h2 class="mb-1 mt-5 has-text-weight-semibold">FUNCTIONS</h2>
            <!-- VARIABLES FUNCTIONS ITEM -->
            <TreeView :data="functions" :start-depth="1" :filter="filter.tab_assets" />
          </div>
        </div>
      </div>
      <!--  -->
      <!-- TAB MEDIA CONTAINER -->
      <!--  -->
      <div id="tab_media" class="tab-content is-height-100" style="display: none">
        <div class="is-flex is-flex-direction-column is-height-100">
          <div class="is-scroll-container">
            <h2 class="mb-1 has-text-weight-semibold">AUDIO</h2>
            <MediaTreeView :data="groupedMedia.Audio" :filter="filter.tab_media" />
            <h2 class="mb-1 mt-5 has-text-weight-semibold">IMAGE</h2>
            <MediaTreeView :data="groupedMedia.Image" :filter="filter.tab_media" />
            <h2 class="mb-1 mt-5 has-text-weight-semibold">OTHER</h2>
            <MediaTreeView :data="groupedMedia.Other" :filter="filter.tab_media" />
          </div>
        </div>
      </div>
    </div>
  </aside>
</template>
